Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 2106)
+++ palm/trunk/SOURCE/modules.f90	(revision 2107)
@@ -601,317 +862,520 @@
 
     TYPE plot_precision
-       CHARACTER (LEN=8) ::  variable
-       INTEGER(iwp)      ::  precision
+       CHARACTER (LEN=8) ::  variable   !< 
+       INTEGER(iwp)      ::  precision  !< 
     END TYPE plot_precision
 
-    TYPE(plot_precision), DIMENSION(100) ::  plot_3d_precision =               &
-                        (/ plot_precision( 'u', 2 ), plot_precision( 'v', 2 ), &
-                           plot_precision( 'w', 2 ), plot_precision( 'p', 5 ), &
-                           plot_precision( 'pt', 2 ),                          &
+    TYPE(plot_precision), DIMENSION(100) ::  plot_3d_precision =               &  !< 
+                        (/ plot_precision( 'u', 2 ), plot_precision( 'v', 2 ), & 
+                           plot_precision( 'w', 2 ), plot_precision( 'p', 5 ), & 
+                           plot_precision( 'pt', 2 ),                          & 
                            ( plot_precision( ' ', 1 ), i9 = 1,95 ) /)
 
     TYPE file_status
-       LOGICAL ::  opened, opened_before
+       LOGICAL ::  opened         !< 
+       LOGICAL ::  opened_before  !< 
     END TYPE file_status
     
-    INTEGER, PARAMETER :: mask_xyz_dimension = 100, max_masks = 50
-    INTEGER(iwp), PARAMETER ::  varnamelength = 30  !< length of output variable names
-
-    TYPE(file_status), DIMENSION(200+2*max_masks) ::                &
+    INTEGER, PARAMETER      ::  mask_xyz_dimension = 100  !< 
+    INTEGER, PARAMETER      ::  max_masks = 50            !< 
+    INTEGER(iwp), PARAMETER ::  varnamelength = 30        !< length of output variable names
+
+    TYPE(file_status), DIMENSION(200+2*max_masks) ::                &  !< 
                              openfile = file_status(.FALSE.,.FALSE.)
 
-    CHARACTER (LEN=1)    ::  cycle_mg = 'w', timestep_reason = ' '
-    CHARACTER (LEN=3)    ::  coupling_char = ''
-    CHARACTER (LEN=5)    ::  write_binary = 'false'
-    CHARACTER (LEN=8)    ::  most_method = 'lookup', & !< NAMELIST parameter defining method to be used to calculate Okukhov length, 
-                             run_date,               & !< 
-                             run_time                  !< 
-    CHARACTER (LEN=9)    ::  simulated_time_chr
-    CHARACTER (LEN=11)   ::  topography_grid_convention = ' '
-    CHARACTER (LEN=12)   ::  version = ' ', revision = ' ', &
-                             user_interface_current_revision = ' ', &
-                             user_interface_required_revision = ' '
-    CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default', &
-                             loop_optimization = 'default', &
-                             momentum_advec = 'ws-scheme', &
-                             psolver = 'poisfft', &
-                             scalar_advec = 'ws-scheme'
-    CHARACTER (LEN=20)   ::  approximation = 'boussinesq'
-    CHARACTER (LEN=40)   ::  flux_input_mode = 'approximation-specific'
-    CHARACTER (LEN=40)   ::  flux_output_mode = 'approximation-specific'
-    CHARACTER (LEN=20)   ::  bc_e_b = 'neumann', bc_lr = 'cyclic', &
-                             bc_ns = 'cyclic', bc_p_b = 'neumann', &
-                             bc_p_t = 'dirichlet', bc_pt_b = 'dirichlet', &
-                             bc_pt_t = 'initial_gradient', &
-                             bc_q_b = 'dirichlet', bc_q_t = 'neumann', &
-                             bc_s_b = 'dirichlet', bc_s_t = 'initial_gradient', &
-                             bc_sa_t = 'neumann', &
-                             bc_uv_b = 'dirichlet', bc_uv_t = 'dirichlet', &
-                             cloud_scheme = 'saturation_adjust', &
-                             coupling_mode = 'uncoupled', &
-                             coupling_mode_remote = 'uncoupled', &
-                             dissipation_1d = 'detering', &
-                             fft_method = 'system-specific', &
-                             mixing_length_1d = 'blackadar', &
-                             random_generator = 'numerical-recipes', &
-                             reference_state = 'initial_profile', &
-                             return_addres, return_username, &
-                             timestep_scheme = 'runge-kutta-3'                             
-    CHARACTER (LEN=40)   ::  avs_data_file, topography = 'flat'
-    CHARACTER (LEN=64)   ::  host = ' '
-    CHARACTER (LEN=80)   ::  log_message, run_identifier
-    CHARACTER (LEN=100)  ::  initializing_actions = ' ' 
-    CHARACTER (LEN=110)  ::  run_description_header
-    CHARACTER (LEN=1000) ::  message_string = ' '
-
-    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output = ' ',    &
-                                           data_output_user = ' ', doav = ' '
-    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  &
-         data_output_masks = ' ', data_output_masks_user = ' '
-
-    CHARACTER (LEN=varnamelength), DIMENSION(300) ::  data_output_pr = ' '
-    CHARACTER (LEN=varnamelength), DIMENSION(200) ::  data_output_pr_user = ' '
-    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,0:1,100) ::  domask = ' '
-    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do2d = ' ', do3d = ' '
-
-    INTEGER(iwp), PARAMETER :: fl_max = 100, var_fl_max = 20
+    CHARACTER (LEN=1)    ::  cycle_mg = 'w'                               !< 
+    CHARACTER (LEN=1)    ::  timestep_reason = ' '                        !< 
+    CHARACTER (LEN=3)    ::  coupling_char = ''                           !< 
+    CHARACTER (LEN=5)    ::  write_binary = 'false'                       !< 
+    CHARACTER (LEN=8)    ::  most_method = 'lookup'                       !< NAMELIST parameter defining method to be used to calculate Okukhov length, 
+    CHARACTER (LEN=8)    ::  run_date                                     !< 
+    CHARACTER (LEN=8)    ::  run_time                                     !< 
+    CHARACTER (LEN=9)    ::  simulated_time_chr                           !< 
+    CHARACTER (LEN=11)   ::  topography_grid_convention = ' '             !< 
+    CHARACTER (LEN=12)   ::  version = ' '                                !< 
+    CHARACTER (LEN=12)   ::  revision = ' '                               !< 
+    CHARACTER (LEN=12)   ::  user_interface_current_revision = ' '        !< 
+    CHARACTER (LEN=12)   ::  user_interface_required_revision = ' '       !< 
+    CHARACTER (LEN=16)   ::  conserve_volume_flow_mode = 'default'        !< 
+    CHARACTER (LEN=16)   ::  loop_optimization = 'default'                !< 
+    CHARACTER (LEN=16)   ::  momentum_advec = 'ws-scheme'                 !< 
+    CHARACTER (LEN=16)   ::  psolver = 'poisfft'                          !<  
+    CHARACTER (LEN=16)   ::  scalar_advec = 'ws-scheme'                   !< 
+    CHARACTER (LEN=20)   ::  approximation = 'boussinesq'                 !<  
+    CHARACTER (LEN=40)   ::  flux_input_mode = 'approximation-specific'   !< 
+    CHARACTER (LEN=40)   ::  flux_output_mode = 'approximation-specific'  !< 
+    CHARACTER (LEN=20)   ::  bc_e_b = 'neumann'                           !< 
+    CHARACTER (LEN=20)   ::  bc_lr = 'cyclic'                             !< 
+    CHARACTER (LEN=20)   ::  bc_ns = 'cyclic'                             !< 
+    CHARACTER (LEN=20)   ::  bc_p_b = 'neumann'                           !< 
+    CHARACTER (LEN=20)   ::  bc_p_t = 'dirichlet'                         !< 
+    CHARACTER (LEN=20)   ::  bc_pt_b = 'dirichlet'                        !< 
+    CHARACTER (LEN=20)   ::  bc_pt_t = 'initial_gradient'                 !< 
+    CHARACTER (LEN=20)   ::  bc_q_b = 'dirichlet'                         !< 
+    CHARACTER (LEN=20)   ::  bc_q_t = 'neumann'                           !< 
+    CHARACTER (LEN=20)   ::  bc_s_b = 'dirichlet'                         !< 
+    CHARACTER (LEN=20)   ::  bc_s_t = 'initial_gradient'                  !< 
+    CHARACTER (LEN=20)   ::  bc_sa_t = 'neumann'                          !< 
+    CHARACTER (LEN=20)   ::  bc_uv_b = 'dirichlet'                        !< 
+    CHARACTER (LEN=20)   ::  bc_uv_t = 'dirichlet'                        !< 
+    CHARACTER (LEN=20)   ::  cloud_scheme = 'saturation_adjust'           !< 
+    CHARACTER (LEN=20)   ::  coupling_mode = 'uncoupled'                  !<    
+    CHARACTER (LEN=20)   ::  coupling_mode_remote = 'uncoupled'           !< 
+    CHARACTER (LEN=20)   ::  dissipation_1d = 'detering'                  !< 
+    CHARACTER (LEN=20)   ::  fft_method = 'system-specific'               !< 
+    CHARACTER (LEN=20)   ::  mixing_length_1d = 'blackadar'               !< 
+    CHARACTER (LEN=20)   ::  random_generator = 'numerical-recipes'       !< 
+    CHARACTER (LEN=20)   ::  reference_state = 'initial_profile'          !<   
+    CHARACTER (LEN=20)   ::  return_addres                                !< 
+    CHARACTER (LEN=20)   ::  return_username                              !< 
+    CHARACTER (LEN=20)   ::  timestep_scheme = 'runge-kutta-3'            !<        
+    CHARACTER (LEN=40)   ::  avs_data_file                                !< 
+    CHARACTER (LEN=40)   ::  topography = 'flat'                          !<  
+    CHARACTER (LEN=64)   ::  host = ' '                                   !< 
+    CHARACTER (LEN=80)   ::  log_message                                  !< 
+    CHARACTER (LEN=80)   ::  run_identifier                               !<  
+    CHARACTER (LEN=100)  ::  initializing_actions = ' '                   !< 
+    CHARACTER (LEN=110)  ::  run_description_header                       !< 
+    CHARACTER (LEN=1000) ::  message_string = ' '                         !< 
+
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output = ' '       !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  data_output_user = ' '  !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(500) ::  doav = ' '              !<
+                                            
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks = ' '       !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,100) ::  data_output_masks_user = ' '  !< 
+
+    CHARACTER (LEN=varnamelength), DIMENSION(300) ::  data_output_pr = ' '  !< 
     
-    INTEGER(iwp) ::  abort_mode = 1, average_count_pr = 0, &
-                     average_count_3d = 0, current_timestep_number = 0, &
-                     coupling_topology = 0, &
-                     dist_range = 0, disturbance_level_ind_b, &
-                     disturbance_level_ind_t, doav_n = 0, dopr_n = 0, &
-                     dopr_time_count = 0, dopts_time_count = 0, &
-                     dots_time_count = 0, &
-                     do2d_xy_n = 0, do2d_xz_n = 0, do2d_yz_n = 0, do3d_avs_n = 0, &
-                     dp_level_ind_b = 0, dvrp_filecount = 0, &
-                     dz_stretch_level_index, ensemble_member_nr = 0, gamma_mg, gathered_size, &
-                     grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
-                     ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, ibc_s_t, &
-                     ibc_sa_t, ibc_uv_b, ibc_uv_t, &
-                     inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
-                     intermediate_timestep_count, intermediate_timestep_count_max, &
-                     io_group = 0, io_blocks = 1, iran = -1234567, &
-                     masks = 0, maximum_grid_level, &
-                     maximum_parallel_io_streams = -1, max_pr_user = 0, &
-                     mgcycles = 0, mg_cycles = -1, mg_switch_to_pe0_level = -1, mid, &
-                     nlsf = 1000, ntnudge = 1000, ngsrb = 2, &
-                     nr_timesteps_this_run = 0, &
-                     nsor = 20, nsor_ini = 100, n_sor, normalizing_region = 0, &
-                     num_leg=0, num_var_fl, num_var_fl_user=0, &
-                     nz_do3d = -9999, prt_time_count = 0, &
-                     recycling_plane, runnr = 0, &
-                     skip_do_avs = 0, subdomain_size, terminate_coupled = 0, &
-                     terminate_coupled_remote = 0, timestep_count = 0
-
-    INTEGER(iwp) ::  dist_nxl(0:1), dist_nxr(0:1), dist_nyn(0:1), dist_nys(0:1), &
-                     do2d_no(0:1) = 0, do2d_xy_time_count(0:1), &
-                     do2d_xz_time_count(0:1), do2d_yz_time_count(0:1), &
-                     do3d_no(0:1) = 0, do3d_time_count(0:1), &
-                     domask_no(max_masks,0:1) = 0, domask_time_count(max_masks,0:1),&
-                     mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
-                     mask_start_l(max_masks,3) = -1, &
-                     pt_vertical_gradient_level_ind(10) = -9999, &
-                     q_vertical_gradient_level_ind(10) = -9999, &
-                     s_vertical_gradient_level_ind(10) = -9999, &                     
-                     sa_vertical_gradient_level_ind(10) = -9999, &
-                     section(100,3), section_xy(100) = -9999, &
-                     section_xz(100) = -9999, section_yz(100) = -9999, &
-                     ug_vertical_gradient_level_ind(10) = -9999, &
-                     vg_vertical_gradient_level_ind(10) = -9999, &
-                     subs_vertical_gradient_level_i(10) = -9999
-
-
-    INTEGER(iwp), DIMENSION(0:1) :: ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz, ntdim_3d
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  grid_level_count
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  mask_i, mask_j, mask_k
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  &
-                    mask_i_global, mask_j_global, mask_k_global
-
-    LOGICAL ::  bc_lr_cyc =.TRUE., bc_lr_dirrad = .FALSE., &
-                bc_lr_raddir = .FALSE., bc_ns_cyc = .TRUE., &
-                bc_ns_dirrad = .FALSE., bc_ns_raddir = .FALSE.,&
-                call_microphysics_at_all_substeps = .FALSE., &
-                call_psolver_at_all_substeps = .TRUE., &
-                cloud_droplets = .FALSE., cloud_physics = .FALSE., &
-                cloud_top_radiation = .FALSE., &
-                conserve_volume_flow = .FALSE., constant_diffusion = .FALSE., &
-                constant_flux_layer = .TRUE., &
-                constant_heatflux = .TRUE., constant_top_heatflux = .TRUE., &
-                constant_top_momentumflux = .FALSE., &
-                constant_top_salinityflux = .TRUE., &
-                constant_top_scalarflux = .TRUE., &
-                constant_scalarflux = .TRUE., &              
-                constant_waterflux = .TRUE., create_disturbances = .TRUE., &
-                data_output_2d_on_each_pe = .TRUE., & 
-                dissipation_control = .FALSE., disturbance_created = .FALSE., &
-                do2d_at_begin = .FALSE., do3d_at_begin = .FALSE., &
-                do_sum = .FALSE., &
-                dp_external = .FALSE., dp_smooth = .FALSE., &
-                dt_fixed = .FALSE., &
-                dt_3d_reached, dt_3d_reached_l, exchange_mg = .FALSE., &
-                first_call_lpm = .TRUE., &
-                force_print_header = .FALSE., galilei_transformation = .FALSE.,&
-                humidity = .FALSE., humidity_remote = .FALSE., &
-                inflow_l = .FALSE., inflow_n = .FALSE., &
-                inflow_r = .FALSE., inflow_s = .FALSE., &
-                large_scale_forcing = .FALSE., &
-                large_scale_subsidence = .FALSE.
-    LOGICAL ::  lsf_exception = .FALSE.  !< temporary flag for use of lsf with buildings on flat terrain
-    LOGICAL ::  lsf_surf = .TRUE., &
-                lsf_vert = .TRUE., lptnudge = .FALSE., lqnudge = .FALSE., &
-                lunudge = .FALSE., lvnudge = .FALSE., lwnudge = .FALSE., &
-                masking_method = .FALSE., &
-                microphysics_sat_adjust = .FALSE., &
-                microphysics_kessler = .FALSE., &
-                microphysics_seifert = .FALSE., &
-                mg_switch_to_pe0 = .FALSE., &
-                monotonic_adjustment = .FALSE.
-    LOGICAL ::  nest_bound_l = .FALSE. !< nested boundary on left side
-    LOGICAL ::  nest_bound_n = .FALSE. !< nested boundary on north side
-    LOGICAL ::  nest_bound_r = .FALSE. !< nested boundary on right side
-    LOGICAL ::  nest_bound_s = .FALSE. !< nested boundary on south side
-    LOGICAL ::  nest_domain  = .FALSE. !< domain is nested into a parent domain
-    LOGICAL ::  neutral = .FALSE., nudging = .FALSE., &
-                ocean = .FALSE., on_device = .FALSE., &
-                outflow_l = .FALSE., outflow_n = .FALSE., outflow_r = .FALSE., &
-                outflow_s = .FALSE., passive_scalar = .FALSE., &
-                precipitation = .FALSE., &
-                random_heatflux = .FALSE., recycling_yshift = .FALSE.,&
-                run_control_header = .FALSE., run_coupled = .TRUE., &
-                scalar_rayleigh_damping = .TRUE., sloping_surface = .FALSE., &
-                stop_dt = .FALSE., synchronous_exchange = .FALSE., &
-                terminate_run = .FALSE., transpose_compute_overlap = .FALSE., &
-                turbulent_inflow = .FALSE.
-    LOGICAL ::  turbulent_outflow = .FALSE. !< flag for turbulent outflow condition
-    LOGICAL ::  urban_surface = .FALSE.  !< flag for urban surface model
-    LOGICAL ::  use_cmax = .TRUE., use_initial_profile_as_reference = .FALSE., &
-                use_prescribed_profile_data = .FALSE., &
-                use_single_reference_value = .FALSE., &
-                use_subsidence_tendencies = .FALSE., &
-                use_surface_fluxes = .FALSE., use_top_fluxes = .FALSE., &
-                use_ug_for_galilei_tr = .TRUE., use_upstream_for_tke = .FALSE.
-    LOGICAL ::  virtual_flight = .FALSE.  !< flag for virtual flight model
-    LOGICAL ::  wall_adjustment = .TRUE., ws_scheme_sca = .FALSE., &
-                ws_scheme_mom = .FALSE.
-
-    LOGICAL ::  data_output_xy(0:1) = .FALSE., data_output_xz(0:1) = .FALSE., &
-                data_output_yz(0:1) = .FALSE.
-
-    REAL(wp) ::  advected_distance_x = 0.0_wp, advected_distance_y = 0.0_wp, &
-                 alpha_surface = 0.0_wp, atmos_ocean_sign = 1.0_wp, &
-                 averaging_interval = 0.0_wp, averaging_interval_pr = 9999999.9_wp, &
-                 bc_pt_t_val, bc_q_t_val, bc_s_t_val, bottom_salinityflux = 0.0_wp, &
-                 building_height = 50.0_wp, building_length_x = 50.0_wp, &
-                 building_length_y = 50.0_wp, building_wall_left = 9999999.9_wp, &
-                 building_wall_south = 9999999.9_wp, canyon_height = 50.0_wp, &
-                 canyon_width_x = 9999999.9_wp, canyon_width_y = 9999999.9_wp, &
-                 canyon_wall_left = 9999999.9_wp, canyon_wall_south = 9999999.9_wp, &
-                 cfl_factor = -1.0_wp, cos_alpha_surface, &
-                 coupling_start_time = 0.0_wp, disturbance_amplitude = 0.25_wp, &
-                 disturbance_energy_limit = 0.01_wp, &
-                 disturbance_level_b = -9999999.9_wp, &
-                 disturbance_level_t = -9999999.9_wp, &
-                 dp_level_b = 0.0_wp, &
-                 dt = -1.0_wp, dt_averaging_input = 0.0_wp, &
-                 dt_averaging_input_pr = 9999999.9_wp, dt_coupling = 9999999.9_wp, &
-                 dt_data_output = 9999999.9_wp, &
-                 dt_data_output_av = 9999999.9_wp, dt_disturb = 9999999.9_wp, &
-                 dt_dopr = 9999999.9_wp, dt_dopr_listing = 9999999.9_wp, &
-                 dt_dopts = 9999999.9_wp, dt_dots = 9999999.9_wp, &
-                 dt_do2d_xy = 9999999.9_wp, dt_do2d_xz = 9999999.9_wp, &
-                 dt_do2d_yz = 9999999.9_wp, dt_do3d = 9999999.9_wp, dt_dvrp = 9999999.9_wp, &
-                 dt_max = 20.0_wp, &
-                 dt_restart = 9999999.9_wp, &
-                 dt_run_control = 60.0_wp, dt_3d = 1.0_wp, dz = -1.0_wp, &
-                 dz_max = 9999999.9_wp, dz_stretch_factor = 1.08_wp, &
-                 dz_stretch_level = 100000.0_wp, e_init = 0.0_wp, e_min = 0.0_wp, &
-                 end_time = 0.0_wp, &
-                 f = 0.0_wp, fs = 0.0_wp, g = 9.81_wp, inflow_damping_height = 9999999.9_wp, &
-                 inflow_damping_width = 9999999.9_wp, kappa = 0.4_wp, km_constant = -1.0_wp,&
-                 mask_scale_x = 1.0_wp, mask_scale_y = 1.0_wp, mask_scale_z = 1.0_wp, &
-                 maximum_cpu_time_allowed = 0.0_wp,  &
-                 molecular_viscosity = 1.461E-5_wp, &
-                 old_dt = 1.0E-10_wp, omega = 7.29212E-5_wp, omega_sor = 1.8_wp, &
-                 outflow_source_plane = -9999999.9_wp, & !< x-position of outflow-source plane (turbulent outflow method)
-                 particle_maximum_age = 9999999.9_wp, &
-                 phi = 55.0_wp, prandtl_number = 1.0_wp, &
-                 precipitation_amount_interval = 9999999.9_wp, prho_reference, &
-                 pt_damping_factor = 0.0_wp, pt_damping_width = 0.0_wp, &
-                 pt_reference = 9999999.9_wp, pt_slope_offset = 0.0_wp, &
-                 pt_surface = 300.0_wp, pt_surface_initial_change = 0.0_wp, &
-                 q_surface = 0.0_wp, q_surface_initial_change = 0.0_wp, &
-                 rayleigh_damping_factor = -1.0_wp, rayleigh_damping_height = -1.0_wp, &
-                 recycling_width = 9999999.9_wp, residual_limit = 1.0E-4_wp, &
-                 restart_time = 9999999.9_wp, rho_reference, rho_surface, &
-                 roughness_length = 0.1_wp, &
-                 sa_surface = 35.0_wp, &
-                 simulated_time = 0.0_wp, simulated_time_at_begin, sin_alpha_surface, &
-                 skip_time_data_output = 0.0_wp, skip_time_data_output_av = 9999999.9_wp,&
-                 skip_time_dopr = 9999999.9_wp, &
-                 skip_time_do2d_xy = 9999999.9_wp, skip_time_do2d_xz = 9999999.9_wp, &
-                 skip_time_do2d_yz = 9999999.9_wp, skip_time_do3d = 9999999.9_wp, &
-                 surface_heatflux = 9999999.9_wp, surface_pressure = 1013.25_wp, &
-                 surface_scalarflux = 9999999.9_wp, surface_waterflux = 9999999.9_wp, &
-                 s_surface = 0.0_wp, s_surface_initial_change = 0.0_wp, &
-                 termination_time_needed = -1.0_wp, time_coupling = 0.0_wp, &
-                 time_disturb = 0.0_wp, time_dopr = 0.0_wp, time_dopr_av = 0.0_wp, &
-                 time_dopr_listing = 0.0_wp, time_dopts = 0.0_wp, time_dosp = 0.0_wp, &
-                 time_dosp_av = 0.0_wp, time_dots = 0.0_wp, time_do2d_xy = 0.0_wp, &
-                 time_do2d_xz = 0.0_wp, time_do2d_yz = 0.0_wp, time_do3d = 0.0_wp, &
-                 time_do_av = 0.0_wp, time_do_sla = 0.0_wp, time_dvrp = 0.0_wp, &
-                 time_restart = 9999999.9_wp, time_run_control = 0.0_wp,&
-                 time_since_reference_point, top_heatflux = 9999999.9_wp, &
-                 top_momentumflux_u = 9999999.9_wp, &
-                 top_momentumflux_v = 9999999.9_wp, top_salinityflux = 9999999.9_wp, &
-                 top_scalarflux = 9999999.9_wp, &
-                 ug_surface = 0.0_wp, u_bulk = 0.0_wp, u_gtrans = 0.0_wp, &
-                 vg_surface = 0.0_wp, vpt_reference = 9999999.9_wp, &
-                 v_bulk = 0.0_wp, v_gtrans = 0.0_wp, wall_adjustment_factor = 1.8_wp, &
-                 zeta_max = 20.0_wp,    & !< Maximum value of zeta = z/L
-                 zeta_min = -9990.0_wp, & !< Minimum value of zeta = z/L
-                 z_max_do2d = -1.0_wp, z0h_factor = 1.0_wp
-
-    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp, do2d_xz_last_time(0:1) = -1.0_wp, &
-                 do2d_yz_last_time(0:1) = -1.0_wp, dpdxy(1:2) = 0.0_wp, &
-                 dt_domask(max_masks) = 9999999.9_wp, &
-                 mask_scale(3), &
-                 pt_vertical_gradient(10) = 0.0_wp, &
-                 pt_vertical_gradient_level(10) = -1.0_wp, &
-                 q_vertical_gradient(10) = 0.0_wp, &
-                 q_vertical_gradient_level(10) = -1.0_wp, &
-                 s_vertical_gradient(10) = 0.0_wp, &
-                 s_vertical_gradient_level(10) = -1.0_wp, &
-                 sa_vertical_gradient(10) = 0.0_wp, &
-                 sa_vertical_gradient_level(10) = -1.0_wp, &
-                 skip_time_domask(max_masks) = 9999999.9_wp, threshold(20) = 0.0_wp, &
-                 time_domask(max_masks) = 0.0_wp, &
-                 tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp /), &
-                 u_profile(100) = 9999999.9_wp, uv_heights(100) = 9999999.9_wp, &
-                 v_profile(100) = 9999999.9_wp, &
-                 ug_vertical_gradient(10) = 0.0_wp, &
-                 ug_vertical_gradient_level(10) = -9999999.9_wp, &
-                 vg_vertical_gradient(10) = 0.0_wp, &
-                 vg_vertical_gradient_level(10) = -9999999.9_wp, &
-                 volume_flow(1:3) = 0.0_wp, volume_flow_area(1:3) = 0.0_wp, &
-                 volume_flow_initial(1:3) = 0.0_wp, wall_heatflux(0:4) = 0.0_wp, &
-                 wall_humidityflux(0:4) = 0.0_wp, wall_nrflux(0:4) = 0.0_wp, &
-                 wall_qflux(0:4) = 0.0_wp, wall_qrflux(0:4) = 0.0_wp, &
-                 wall_salinityflux(0:4) = 0.0_wp, wall_sflux(0:4) = 0.0_wp, wall_scalarflux(0:4) = 0.0_wp, &
-                 subs_vertical_gradient(10) = 0.0_wp, &
-                 subs_vertical_gradient_level(10) = -9999999.9_wp
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor
-
-    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) :: &
-            mask_x = -1.0_wp, mask_y = -1.0_wp, mask_z = -1.0_wp
-    REAL(wp), DIMENSION(max_masks,3) ::                  &
-            mask_x_loop = -1.0_wp, mask_y_loop = -1.0_wp, mask_z_loop = -1.0_wp
+    CHARACTER (LEN=varnamelength), DIMENSION(200) ::  data_output_pr_user = ' '  !< 
     
+    CHARACTER (LEN=varnamelength), DIMENSION(max_masks,0:1,100) ::  domask = ' ' !< 
+    
+    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do2d = ' '  !< 
+    CHARACTER (LEN=varnamelength), DIMENSION(0:1,500) ::  do3d = ' '  !< 
+
+    INTEGER(iwp), PARAMETER ::  fl_max = 100     !< 
+    INTEGER(iwp), PARAMETER ::  var_fl_max = 20  !< 
+    
+    INTEGER(iwp) ::  abort_mode = 1                    !< 
+    INTEGER(iwp) ::  average_count_pr = 0              !< 
+    INTEGER(iwp) ::  average_count_3d = 0              !< 
+    INTEGER(iwp) ::  current_timestep_number = 0       !< 
+    INTEGER(iwp) ::  coupling_topology = 0             !< 
+    INTEGER(iwp) ::  dist_range = 0                    !< 
+    INTEGER(iwp) ::  disturbance_level_ind_b           !< 
+    INTEGER(iwp) ::  disturbance_level_ind_t           !< 
+    INTEGER(iwp) ::  doav_n = 0                        !< 
+    INTEGER(iwp) ::  dopr_n = 0                        !< 
+    INTEGER(iwp) ::  dopr_time_count = 0               !< 
+    INTEGER(iwp) ::  dopts_time_count = 0              !< 
+    INTEGER(iwp) ::  dots_time_count = 0               !< 
+    INTEGER(iwp) ::  do2d_xy_n = 0                     !< 
+    INTEGER(iwp) ::  do2d_xz_n = 0                     !< 
+    INTEGER(iwp) ::  do2d_yz_n = 0                     !< 
+    INTEGER(iwp) ::  do3d_avs_n = 0                    !< 
+    INTEGER(iwp) ::  dp_level_ind_b = 0                !< 
+    INTEGER(iwp) ::  dvrp_filecount = 0                !< 
+    INTEGER(iwp) ::  dz_stretch_level_index            !< 
+    INTEGER(iwp) ::  ensemble_member_nr = 0            !< 
+    INTEGER(iwp) ::  gamma_mg                          !< 
+    INTEGER(iwp) ::  gathered_size                     !< 
+    INTEGER(iwp) ::  grid_level                        !< 
+    INTEGER(iwp) ::  ibc_e_b                           !< 
+    INTEGER(iwp) ::  ibc_p_b                           !< 
+    INTEGER(iwp) ::  ibc_p_t                           !< 
+    INTEGER(iwp) ::  ibc_pt_b                          !< 
+    INTEGER(iwp) ::  ibc_pt_t                          !< 
+    INTEGER(iwp) ::  ibc_q_b                           !< 
+    INTEGER(iwp) ::  ibc_q_t                           !< 
+    INTEGER(iwp) ::  ibc_s_b                           !< 
+    INTEGER(iwp) ::  ibc_s_t                           !< 
+    INTEGER(iwp) ::  ibc_sa_t                          !< 
+    INTEGER(iwp) ::  ibc_uv_b                          !< 
+    INTEGER(iwp) ::  ibc_uv_t                          !< 
+    INTEGER(iwp) ::  inflow_disturbance_begin = -1     !< 
+    INTEGER(iwp) ::  inflow_disturbance_end = -1       !< 
+    INTEGER(iwp) ::  intermediate_timestep_count       !< 
+    INTEGER(iwp) ::  intermediate_timestep_count_max   !< 
+    INTEGER(iwp) ::  io_group = 0                      !< 
+    INTEGER(iwp) ::  io_blocks = 1                     !< 
+    INTEGER(iwp) ::  iran = -1234567                   !< 
+    INTEGER(iwp) ::  masks = 0                         !< 
+    INTEGER(iwp) ::  maximum_grid_level                !< 
+    INTEGER(iwp) ::  maximum_parallel_io_streams = -1  !< 
+    INTEGER(iwp) ::  max_pr_user = 0                   !< 
+    INTEGER(iwp) ::  mgcycles = 0                      !< 
+    INTEGER(iwp) ::  mg_cycles = -1                    !< 
+    INTEGER(iwp) ::  mg_switch_to_pe0_level = -1       !< 
+    INTEGER(iwp) ::  mid                               !< 
+    INTEGER(iwp) ::  nlsf = 1000                       !< 
+    INTEGER(iwp) ::  ntnudge = 1000                    !< 
+    INTEGER(iwp) ::  ngsrb = 2                         !< 
+    INTEGER(iwp) ::  nr_timesteps_this_run = 0         !< 
+    INTEGER(iwp) ::  nsor = 20                         !< 
+    INTEGER(iwp) ::  nsor_ini = 100                    !< 
+    INTEGER(iwp) ::  n_sor                             !< 
+    INTEGER(iwp) ::  normalizing_region = 0            !< 
+    INTEGER(iwp) ::  num_leg=0                         !< 
+    INTEGER(iwp) ::  num_var_fl                        !< 
+    INTEGER(iwp) ::  num_var_fl_user=0                 !< 
+    INTEGER(iwp) ::  nz_do3d = -9999                   !< 
+    INTEGER(iwp) ::  prt_time_count = 0                !< 
+    INTEGER(iwp) ::  recycling_plane                   !< 
+    INTEGER(iwp) ::  runnr = 0                         !< 
+    INTEGER(iwp) ::  skip_do_avs = 0                   !< 
+    INTEGER(iwp) ::  subdomain_size                    !< 
+    INTEGER(iwp) ::  terminate_coupled = 0             !< 
+    INTEGER(iwp) ::  terminate_coupled_remote = 0      !< 
+    INTEGER(iwp) ::  timestep_count = 0                !< 
+
+    INTEGER(iwp) ::  dist_nxl(0:1)                               !< 
+    INTEGER(iwp) ::  dist_nxr(0:1)                               !< 
+    INTEGER(iwp) ::  dist_nyn(0:1)                               !< 
+    INTEGER(iwp) ::  dist_nys(0:1)                               !< 
+    INTEGER(iwp) ::  do2d_no(0:1) = 0                            !< 
+    INTEGER(iwp) ::  do2d_xy_time_count(0:1)                     !< 
+    INTEGER(iwp) ::  do2d_xz_time_count(0:1)                     !< 
+    INTEGER(iwp) ::  do2d_yz_time_count(0:1)                     !< 
+    INTEGER(iwp) ::  do3d_no(0:1) = 0                            !< 
+    INTEGER(iwp) ::  do3d_time_count(0:1)                        !< 
+    INTEGER(iwp) ::  domask_no(max_masks,0:1) = 0                !< 
+    INTEGER(iwp) ::  domask_time_count(max_masks,0:1)            !< 
+    INTEGER(iwp) ::  mask_size(max_masks,3) = -1                 !< 
+    INTEGER(iwp) ::  mask_size_l(max_masks,3) = -1               !< 
+    INTEGER(iwp) ::  mask_start_l(max_masks,3) = -1              !< 
+    INTEGER(iwp) ::  pt_vertical_gradient_level_ind(10) = -9999  !< 
+    INTEGER(iwp) ::  q_vertical_gradient_level_ind(10) = -9999   !< 
+    INTEGER(iwp) ::  s_vertical_gradient_level_ind(10) = -9999   !<                
+    INTEGER(iwp) ::  sa_vertical_gradient_level_ind(10) = -9999  !< 
+    INTEGER(iwp) ::  section(100,3)                              !< 
+    INTEGER(iwp) ::  section_xy(100) = -9999                     !< 
+    INTEGER(iwp) ::  section_xz(100) = -9999                     !< 
+    INTEGER(iwp) ::  section_yz(100) = -9999                     !< 
+    INTEGER(iwp) ::  ug_vertical_gradient_level_ind(10) = -9999  !< 
+    INTEGER(iwp) ::  vg_vertical_gradient_level_ind(10) = -9999  !< 
+    INTEGER(iwp) ::  subs_vertical_gradient_level_i(10) = -9999  !< 
+
+
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xy  !< 
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_xz  !< 
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_2d_yz  !< 
+    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_3d     !< 
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  grid_level_count  !< 
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i         !< 
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j         !< 
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k         !< 
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_i_global  !<   
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_j_global  !< 
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mask_k_global  !< 
+
+    LOGICAL ::  bc_lr_cyc =.TRUE.                            !< 
+    LOGICAL ::  bc_lr_dirrad = .FALSE.                       !< 
+    LOGICAL ::  bc_lr_raddir = .FALSE.                       !< 
+    LOGICAL ::  bc_ns_cyc = .TRUE.                           !< 
+    LOGICAL ::  bc_ns_dirrad = .FALSE.                       !< 
+    LOGICAL ::  bc_ns_raddir = .FALSE.                       !< 
+    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.  !< 
+    LOGICAL ::  call_psolver_at_all_substeps = .TRUE.        !< 
+    LOGICAL ::  cloud_droplets = .FALSE.                     !< 
+    LOGICAL ::  cloud_physics = .FALSE.                      !< 
+    LOGICAL ::  cloud_top_radiation = .FALSE.                !< 
+    LOGICAL ::  conserve_volume_flow = .FALSE.               !< 
+    LOGICAL ::  constant_diffusion = .FALSE.                 !< 
+    LOGICAL ::  constant_flux_layer = .TRUE.                 !< 
+    LOGICAL ::  constant_heatflux = .TRUE.                   !<  
+    LOGICAL ::  constant_top_heatflux = .TRUE.               !< 
+    LOGICAL ::  constant_top_momentumflux = .FALSE.          !< 
+    LOGICAL ::  constant_top_salinityflux = .TRUE.           !< 
+    LOGICAL ::  constant_top_scalarflux = .TRUE.             !< 
+    LOGICAL ::  constant_scalarflux = .TRUE.                 !< 
+    LOGICAL ::  constant_waterflux = .TRUE.                  !< 
+    LOGICAL ::  create_disturbances = .TRUE.                 !< 
+    LOGICAL ::  data_output_2d_on_each_pe = .TRUE.           !< 
+    LOGICAL ::  dissipation_control = .FALSE.                !< 
+    LOGICAL ::  disturbance_created = .FALSE.                !< 
+    LOGICAL ::  do2d_at_begin = .FALSE.                      !< 
+    LOGICAL ::  do3d_at_begin = .FALSE.                      !< 
+    LOGICAL ::  do_sum = .FALSE.                             !< 
+    LOGICAL ::  dp_external = .FALSE.                        !< 
+    LOGICAL ::  dp_smooth = .FALSE.                          !< 
+    LOGICAL ::  dt_fixed = .FALSE.                           !< 
+    LOGICAL ::  dt_3d_reached                                !< 
+    LOGICAL ::  dt_3d_reached_l                              !< 
+    LOGICAL ::  exchange_mg = .FALSE.                        !< 
+    LOGICAL ::  first_call_lpm = .TRUE.                      !< 
+    LOGICAL ::  force_print_header = .FALSE.                 !< 
+    LOGICAL ::  galilei_transformation = .FALSE.             !< 
+    LOGICAL ::  humidity = .FALSE.                           !< 
+    LOGICAL ::  humidity_remote = .FALSE.                    !< 
+    LOGICAL ::  inflow_l = .FALSE.                           !< 
+    LOGICAL ::  inflow_n = .FALSE.                           !< 
+    LOGICAL ::  inflow_r = .FALSE.                           !< 
+    LOGICAL ::  inflow_s = .FALSE.                           !< 
+    LOGICAL ::  large_scale_forcing = .FALSE.                !< 
+    LOGICAL ::  large_scale_subsidence = .FALSE.             !< 
+    LOGICAL ::  lsf_exception = .FALSE.                      !< temporary flag for use of lsf with buildings on flat terrain
+    LOGICAL ::  lsf_surf = .TRUE.                            !< 
+    LOGICAL ::  lsf_vert = .TRUE.                            !< 
+    LOGICAL ::  lptnudge = .FALSE.                           !< 
+    LOGICAL ::  lqnudge = .FALSE.                            !< 
+    LOGICAL ::  lunudge = .FALSE.                            !< 
+    LOGICAL ::  lvnudge = .FALSE.                            !< 
+    LOGICAL ::  lwnudge = .FALSE.                            !< 
+    LOGICAL ::  masking_method = .FALSE.                     !< 
+    LOGICAL ::  microphysics_sat_adjust = .FALSE.            !< 
+    LOGICAL ::  microphysics_kessler = .FALSE.               !< 
+    LOGICAL ::  microphysics_seifert = .FALSE.               !< 
+    LOGICAL ::  mg_switch_to_pe0 = .FALSE.                   !< 
+    LOGICAL ::  monotonic_adjustment = .FALSE.               !< 
+    LOGICAL ::  nest_bound_l = .FALSE.                       !< nested boundary on left side
+    LOGICAL ::  nest_bound_n = .FALSE.                       !< nested boundary on north side
+    LOGICAL ::  nest_bound_r = .FALSE.                       !< nested boundary on right side
+    LOGICAL ::  nest_bound_s = .FALSE.                       !< nested boundary on south side
+    LOGICAL ::  nest_domain  = .FALSE.                       !< domain is nested into a parent domain
+    LOGICAL ::  neutral = .FALSE.                            !< 
+    LOGICAL ::  nudging = .FALSE.                            !< 
+    LOGICAL ::  ocean = .FALSE.                              !< 
+    LOGICAL ::  on_device = .FALSE.                          !< 
+    LOGICAL ::  outflow_l = .FALSE.                          !< 
+    LOGICAL ::  outflow_n = .FALSE.                          !< 
+    LOGICAL ::  outflow_r = .FALSE.                          !< 
+    LOGICAL ::  outflow_s = .FALSE.                          !< 
+    LOGICAL ::  passive_scalar = .FALSE.                     !< 
+    LOGICAL ::  precipitation = .FALSE.                      !< 
+    LOGICAL ::  random_heatflux = .FALSE.                    !< 
+    LOGICAL ::  recycling_yshift = .FALSE.                   !< 
+    LOGICAL ::  run_control_header = .FALSE.                 !< 
+    LOGICAL ::  run_coupled = .TRUE.                         !< 
+    LOGICAL ::  scalar_rayleigh_damping = .TRUE.             !< 
+    LOGICAL ::  sloping_surface = .FALSE.                    !< 
+    LOGICAL ::  stop_dt = .FALSE.                            !< 
+    LOGICAL ::  synchronous_exchange = .FALSE.               !< 
+    LOGICAL ::  terminate_run = .FALSE.                      !< 
+    LOGICAL ::  transpose_compute_overlap = .FALSE.          !< 
+    LOGICAL ::  turbulent_inflow = .FALSE.                   !< 
+    LOGICAL ::  turbulent_outflow = .FALSE.                  !< flag for turbulent outflow condition
+    LOGICAL ::  urban_surface = .FALSE.                      !< flag for urban surface model
+    LOGICAL ::  use_cmax = .TRUE.                            !< 
+    LOGICAL ::  use_initial_profile_as_reference = .FALSE.   !< 
+    LOGICAL ::  use_prescribed_profile_data = .FALSE.        !< 
+    LOGICAL ::  use_single_reference_value = .FALSE.         !< 
+    LOGICAL ::  use_subsidence_tendencies = .FALSE.          !< 
+    LOGICAL ::  use_surface_fluxes = .FALSE.                 !< 
+    LOGICAL ::  use_top_fluxes = .FALSE.                     !< 
+    LOGICAL ::  use_ug_for_galilei_tr = .TRUE.               !< 
+    LOGICAL ::  use_upstream_for_tke = .FALSE.               !< 
+    LOGICAL ::  virtual_flight = .FALSE.                     !< flag for virtual flight model
+    LOGICAL ::  wall_adjustment = .TRUE.                     !< 
+    LOGICAL ::  ws_scheme_sca = .FALSE.                      !< 
+    LOGICAL ::  ws_scheme_mom = .FALSE.                      !< 
+
+    LOGICAL ::  data_output_xy(0:1) = .FALSE.                !< 
+    LOGICAL ::  data_output_xz(0:1) = .FALSE.                !< 
+    LOGICAL ::  data_output_yz(0:1) = .FALSE.                !< 
+
+    REAL(wp) ::  advected_distance_x = 0.0_wp                  !< 
+    REAL(wp) ::  advected_distance_y = 0.0_wp                  !< 
+    REAL(wp) ::  alpha_surface = 0.0_wp                        !< 
+    REAL(wp) ::  atmos_ocean_sign = 1.0_wp                     !< 
+    REAL(wp) ::  averaging_interval = 0.0_wp                   !< 
+    REAL(wp) ::  averaging_interval_pr = 9999999.9_wp          !< 
+    REAL(wp) ::  bc_pt_t_val                                   !< 
+    REAL(wp) ::  bc_q_t_val                                    !< 
+    REAL(wp) ::  bc_s_t_val                                    !< 
+    REAL(wp) ::  bottom_salinityflux = 0.0_wp                  !< 
+    REAL(wp) ::  building_height = 50.0_wp                     !< 
+    REAL(wp) ::  building_length_x = 50.0_wp                   !< 
+    REAL(wp) ::  building_length_y = 50.0_wp                   !< 
+    REAL(wp) ::  building_wall_left = 9999999.9_wp             !< 
+    REAL(wp) ::  building_wall_south = 9999999.9_wp            !< 
+    REAL(wp) ::  canyon_height = 50.0_wp                       !< 
+    REAL(wp) ::  canyon_width_x = 9999999.9_wp                 !< 
+    REAL(wp) ::  canyon_width_y = 9999999.9_wp                 !< 
+    REAL(wp) ::  canyon_wall_left = 9999999.9_wp               !< 
+    REAL(wp) ::  canyon_wall_south = 9999999.9_wp              !< 
+    REAL(wp) ::  cfl_factor = -1.0_wp                          !< 
+    REAL(wp) ::  cos_alpha_surface                             !< 
+    REAL(wp) ::  coupling_start_time = 0.0_wp                  !< 
+    REAL(wp) ::  disturbance_amplitude = 0.25_wp               !< 
+    REAL(wp) ::  disturbance_energy_limit = 0.01_wp            !< 
+    REAL(wp) ::  disturbance_level_b = -9999999.9_wp           !< 
+    REAL(wp) ::  disturbance_level_t = -9999999.9_wp           !< 
+    REAL(wp) ::  dp_level_b = 0.0_wp                           !< 
+    REAL(wp) ::  dt = -1.0_wp                                  !< 
+    REAL(wp) ::  dt_averaging_input = 0.0_wp                   !< 
+    REAL(wp) ::  dt_averaging_input_pr = 9999999.9_wp          !< 
+    REAL(wp) ::  dt_coupling = 9999999.9_wp                    !< 
+    REAL(wp) ::  dt_data_output = 9999999.9_wp                 !< 
+    REAL(wp) ::  dt_data_output_av = 9999999.9_wp              !< 
+    REAL(wp) ::  dt_disturb = 9999999.9_wp                     !< 
+    REAL(wp) ::  dt_dopr = 9999999.9_wp                        !< 
+    REAL(wp) ::  dt_dopr_listing = 9999999.9_wp                !< 
+    REAL(wp) ::  dt_dopts = 9999999.9_wp                       !< 
+    REAL(wp) ::  dt_dots = 9999999.9_wp                        !< 
+    REAL(wp) ::  dt_do2d_xy = 9999999.9_wp                     !< 
+    REAL(wp) ::  dt_do2d_xz = 9999999.9_wp                     !< 
+    REAL(wp) ::  dt_do2d_yz = 9999999.9_wp                     !< 
+    REAL(wp) ::  dt_do3d = 9999999.9_wp                        !< 
+    REAL(wp) ::  dt_dvrp = 9999999.9_wp                        !< 
+    REAL(wp) ::  dt_max = 20.0_wp                              !< 
+    REAL(wp) ::  dt_restart = 9999999.9_wp                     !< 
+    REAL(wp) ::  dt_run_control = 60.0_wp                      !< 
+    REAL(wp) ::  dt_3d = 1.0_wp                                !< 
+    REAL(wp) ::  dz = -1.0_wp                                  !< 
+    REAL(wp) ::  dz_max = 9999999.9_wp                         !< 
+    REAL(wp) ::  dz_stretch_factor = 1.08_wp                   !< 
+    REAL(wp) ::  dz_stretch_level = 100000.0_wp                !< 
+    REAL(wp) ::  e_init = 0.0_wp                               !< 
+    REAL(wp) ::  e_min = 0.0_wp                                !< 
+    REAL(wp) ::  end_time = 0.0_wp                             !< 
+    REAL(wp) ::  f = 0.0_wp                                    !< 
+    REAL(wp) ::  fs = 0.0_wp                                   !< 
+    REAL(wp) ::  g = 9.81_wp                                   !< 
+    REAL(wp) ::  inflow_damping_height = 9999999.9_wp          !< 
+    REAL(wp) ::  inflow_damping_width = 9999999.9_wp           !< 
+    REAL(wp) ::  kappa = 0.4_wp                                !< 
+    REAL(wp) ::  km_constant = -1.0_wp                         !< 
+    REAL(wp) ::  mask_scale_x = 1.0_wp                         !< 
+    REAL(wp) ::  mask_scale_y = 1.0_wp                         !< 
+    REAL(wp) ::  mask_scale_z = 1.0_wp                         !< 
+    REAL(wp) ::  maximum_cpu_time_allowed = 0.0_wp             !< 
+    REAL(wp) ::  molecular_viscosity = 1.461E-5_wp             !< 
+    REAL(wp) ::  old_dt = 1.0E-10_wp                           !< 
+    REAL(wp) ::  omega = 7.29212E-5_wp                         !< 
+    REAL(wp) ::  omega_sor = 1.8_wp                            !< 
+    REAL(wp) ::  outflow_source_plane = -9999999.9_wp          !< x-position of outflow-source plane (turbulent outflow method)
+    REAL(wp) ::  particle_maximum_age = 9999999.9_wp           !< 
+    REAL(wp) ::  phi = 55.0_wp                                 !< 
+    REAL(wp) ::  prandtl_number = 1.0_wp                       !< 
+    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp  !< 
+    REAL(wp) ::  prho_reference                                !< 
+    REAL(wp) ::  pt_damping_factor = 0.0_wp                    !< 
+    REAL(wp) ::  pt_damping_width = 0.0_wp                     !< 
+    REAL(wp) ::  pt_reference = 9999999.9_wp                   !< 
+    REAL(wp) ::  pt_slope_offset = 0.0_wp                      !< 
+    REAL(wp) ::  pt_surface = 300.0_wp                         !< 
+    REAL(wp) ::  pt_surface_initial_change = 0.0_wp            !< 
+    REAL(wp) ::  q_surface = 0.0_wp                            !< 
+    REAL(wp) ::  q_surface_initial_change = 0.0_wp             !< 
+    REAL(wp) ::  rayleigh_damping_factor = -1.0_wp             !< 
+    REAL(wp) ::  rayleigh_damping_height = -1.0_wp             !< 
+    REAL(wp) ::  recycling_width = 9999999.9_wp                !< 
+    REAL(wp) ::  residual_limit = 1.0E-4_wp                    !< 
+    REAL(wp) ::  restart_time = 9999999.9_wp                   !< 
+    REAL(wp) ::  rho_reference                                 !< 
+    REAL(wp) ::  rho_surface                                   !< 
+    REAL(wp) ::  roughness_length = 0.1_wp                     !< 
+    REAL(wp) ::  sa_surface = 35.0_wp                          !< 
+    REAL(wp) ::  simulated_time = 0.0_wp                       !< 
+    REAL(wp) ::  simulated_time_at_begin                       !< 
+    REAL(wp) ::  sin_alpha_surface                             !< 
+    REAL(wp) ::  skip_time_data_output = 0.0_wp                !< 
+    REAL(wp) ::  skip_time_data_output_av = 9999999.9_wp       !< 
+    REAL(wp) ::  skip_time_dopr = 9999999.9_wp                 !< 
+    REAL(wp) ::  skip_time_do2d_xy = 9999999.9_wp              !< 
+    REAL(wp) ::  skip_time_do2d_xz = 9999999.9_wp              !< 
+    REAL(wp) ::  skip_time_do2d_yz = 9999999.9_wp              !< 
+    REAL(wp) ::  skip_time_do3d = 9999999.9_wp                 !< 
+    REAL(wp) ::  surface_heatflux = 9999999.9_wp               !< 
+    REAL(wp) ::  surface_pressure = 1013.25_wp                 !< 
+    REAL(wp) ::  surface_scalarflux = 9999999.9_wp             !< 
+    REAL(wp) ::  surface_waterflux = 9999999.9_wp              !< 
+    REAL(wp) ::  s_surface = 0.0_wp                            !< 
+    REAL(wp) ::  s_surface_initial_change = 0.0_wp             !< 
+    REAL(wp) ::  termination_time_needed = -1.0_wp             !< 
+    REAL(wp) ::  time_coupling = 0.0_wp                        !< 
+    REAL(wp) ::  time_disturb = 0.0_wp                         !< 
+    REAL(wp) ::  time_dopr = 0.0_wp                            !< 
+    REAL(wp) ::  time_dopr_av = 0.0_wp                         !< 
+    REAL(wp) ::  time_dopr_listing = 0.0_wp                    !< 
+    REAL(wp) ::  time_dopts = 0.0_wp                           !< 
+    REAL(wp) ::  time_dosp = 0.0_wp                            !< 
+    REAL(wp) ::  time_dosp_av = 0.0_wp                         !< 
+    REAL(wp) ::  time_dots = 0.0_wp                            !< 
+    REAL(wp) ::  time_do2d_xy = 0.0_wp                         !< 
+    REAL(wp) ::  time_do2d_xz = 0.0_wp                         !< 
+    REAL(wp) ::  time_do2d_yz = 0.0_wp                         !< 
+    REAL(wp) ::  time_do3d = 0.0_wp                            !< 
+    REAL(wp) ::  time_do_av = 0.0_wp                           !< 
+    REAL(wp) ::  time_do_sla = 0.0_wp                          !< 
+    REAL(wp) ::  time_dvrp = 0.0_wp                            !< 
+    REAL(wp) ::  time_restart = 9999999.9_wp                   !< 
+    REAL(wp) ::  time_run_control = 0.0_wp                     !< 
+    REAL(wp) ::  time_since_reference_point                    !< 
+    REAL(wp) ::  top_heatflux = 9999999.9_wp                   !< 
+    REAL(wp) ::  top_momentumflux_u = 9999999.9_wp             !< 
+    REAL(wp) ::  top_momentumflux_v = 9999999.9_wp             !< 
+    REAL(wp) ::  top_salinityflux = 9999999.9_wp               !< 
+    REAL(wp) ::  top_scalarflux = 9999999.9_wp                 !< 
+    REAL(wp) ::  ug_surface = 0.0_wp                           !< 
+    REAL(wp) ::  u_bulk = 0.0_wp                               !< 
+    REAL(wp) ::  u_gtrans = 0.0_wp                             !< 
+    REAL(wp) ::  vg_surface = 0.0_wp                           !< 
+    REAL(wp) ::  vpt_reference = 9999999.9_wp                  !< 
+    REAL(wp) ::  v_bulk = 0.0_wp                               !< 
+    REAL(wp) ::  v_gtrans = 0.0_wp                             !< 
+    REAL(wp) ::  wall_adjustment_factor = 1.8_wp               !< 
+    REAL(wp) ::  zeta_max = 20.0_wp                            !< Maximum value of zeta = z/L
+    REAL(wp) ::  zeta_min = -9990.0_wp                         !< Minimum value of zeta = z/L
+    REAL(wp) ::  z_max_do2d = -1.0_wp                          !< 
+    REAL(wp) ::  z0h_factor = 1.0_wp                           !< 
+
+    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp                  !< 
+    REAL(wp) ::  do2d_xz_last_time(0:1) = -1.0_wp                  !< 
+    REAL(wp) ::  do2d_yz_last_time(0:1) = -1.0_wp                  !< 
+    REAL(wp) ::  dpdxy(1:2) = 0.0_wp                               !< 
+    REAL(wp) ::  dt_domask(max_masks) = 9999999.9_wp               !< 
+    REAL(wp) ::  mask_scale(3)                                     !< 
+    REAL(wp) ::  pt_vertical_gradient(10) = 0.0_wp                 !< 
+    REAL(wp) ::  pt_vertical_gradient_level(10) = -1.0_wp          !< 
+    REAL(wp) ::  q_vertical_gradient(10) = 0.0_wp                  !< 
+    REAL(wp) ::  q_vertical_gradient_level(10) = -1.0_wp           !< 
+    REAL(wp) ::  s_vertical_gradient(10) = 0.0_wp                  !< 
+    REAL(wp) ::  s_vertical_gradient_level(10) = -1.0_wp           !< 
+    REAL(wp) ::  sa_vertical_gradient(10) = 0.0_wp                 !< 
+    REAL(wp) ::  sa_vertical_gradient_level(10) = -1.0_wp          !< 
+    REAL(wp) ::  skip_time_domask(max_masks) = 9999999.9_wp        !< 
+    REAL(wp) ::  threshold(20) = 0.0_wp                            !< 
+    REAL(wp) ::  time_domask(max_masks) = 0.0_wp                   !< 
+    REAL(wp) ::  tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, &    !< 
+                 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp /)
+    REAL(wp) ::  u_profile(100) = 9999999.9_wp                     !< 
+    REAL(wp) ::  uv_heights(100) = 9999999.9_wp                    !< 
+    REAL(wp) ::  v_profile(100) = 9999999.9_wp                     !< 
+    REAL(wp) ::  ug_vertical_gradient(10) = 0.0_wp                 !< 
+    REAL(wp) ::  ug_vertical_gradient_level(10) = -9999999.9_wp    !< 
+    REAL(wp) ::  vg_vertical_gradient(10) = 0.0_wp                 !< 
+    REAL(wp) ::  vg_vertical_gradient_level(10) = -9999999.9_wp    !< 
+    REAL(wp) ::  volume_flow(1:3) = 0.0_wp                         !< 
+    REAL(wp) ::  volume_flow_area(1:3) = 0.0_wp                    !< 
+    REAL(wp) ::  volume_flow_initial(1:3) = 0.0_wp                 !< 
+    REAL(wp) ::  wall_heatflux(0:4) = 0.0_wp                       !< 
+    REAL(wp) ::  wall_humidityflux(0:4) = 0.0_wp                   !< 
+    REAL(wp) ::  wall_nrflux(0:4) = 0.0_wp                         !< 
+    REAL(wp) ::  wall_qflux(0:4) = 0.0_wp                          !< 
+    REAL(wp) ::  wall_qrflux(0:4) = 0.0_wp                         !< 
+    REAL(wp) ::  wall_salinityflux(0:4) = 0.0_wp                   !< 
+    REAL(wp) ::  wall_sflux(0:4) = 0.0_wp                          !< 
+    REAL(wp) ::  wall_scalarflux(0:4) = 0.0_wp                     !< 
+    REAL(wp) ::  subs_vertical_gradient(10) = 0.0_wp               !< 
+    REAL(wp) ::  subs_vertical_gradient_level(10) = -9999999.9_wp  !< 
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor  !< 
+
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_x = -1.0_wp  !< 
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_y = -1.0_wp  !< 
+    REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) ::  mask_z = -1.0_wp  !<
+    
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_x_loop = -1.0_wp  !< 
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_y_loop = -1.0_wp  !< 
+    REAL(wp), DIMENSION(max_masks,3) ::  mask_z_loop = -1.0_wp  !< 
+    
 !
 !--    internal mask arrays ("mask,dimension,selection")
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask, mask_loop
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask       !< 
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  mask_loop  !< 
 
     SAVE
